#ifndef _CPLUSGENERATOR_H_INCLUDED_
#define _CPLUSGENERATOR_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// CPlusGenerator.h
// ----------------
// CPlusGenerator interface module 
//                                                         
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 2000-2018 Bjoern Lemke
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; see the file COPYING.  If not, write to
// the Free Software Foundation, 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.
//                                                         
// INTERFACE MODULE
//
// Class: CPlusGenerator
// 
// Description: Code generation module for generating C++ code
//
///////////////////////////////////////////////////////////////////////////////

// Base includes

#include <lfcbase/Chain.h>
#include <lfcbase/SetT.h>
#include <lfcbase/TreeT.h>
#include <lfcbase/ListT.h>

// Dragon includes

#include "Dragon.h"

class CPlusGenerator : public Dragon {
  
public:


    CPlusGenerator(const Chain& parserName, ParserMode m, bool dynamicTable);

    ~CPlusGenerator();
    
    void generateCode();
    
private:

    void generateHeaderCode();
    void generateMethodCode();
    
};
#endif
