#ifndef _TRANSHASH_H_INCLUDED_
#define _TRANSHASH_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// TransHash.h
// -----------
// dragon transiaiton hash interface defintion
//                                                         
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 2000-2007 Bjoern Lemke
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; see the file COPYING.  If not, write to
// the Free Software Foundation, 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.
//
// INTERFACE MODULE
//
// Class: TransHash
// 
// Description: access to dragon termianal information 
//
///////////////////////////////////////////////////////////////////////////////

#include <lfcbase/SetT.h>
#include <lfcbase/Chain.h>

class TransHash {
public:
    
    TransHash();
    TransHash(const Chain& prod);
    ~TransHash();
    
    void setTransSet( SetT<Chain>& transSet);

    SetT<Chain>& getTransSet();
    
    TransHash& operator = (const TransHash& s);
    bool operator == (const TransHash& s);
    
private:
    
    Chain _prod;
    SetT<Chain> _transSet;
    
};

#endif





